HTTP::FormData::Builder - Crystal 1.10.1

# class HTTP::FormData::Builder

- HTTP::FormData::Builder
- Reference
- Object

##
Overview

Builds a multipart/form-data message.

###
Example

    require "http"

    io = IO::Memory.new
    builder = HTTP::FormData::Builder.new(io, "aA47")
    builder.field("name", "joe")
    file = IO::Memory.new("file contents")
    builder.file("upload", file, HTTP::FormData::FileMetadata.new(filename: "test.txt"))
    builder.finish
    io.to_s # => "--aA47\r\nContent-Disposition: form-data; name=\"name\"\r\n\r\njoe\r\n--aA47\r\nContent-Disposition: form-data; name=\"upload\"; filename=\"test.txt\"\r\n\r\nfile contents\r\n--aA47--"

##
Defined in:

http/formdata/builder.cr

##
Constructors

- .new(io : IO, boundary : String = MIME::Multipart.generate_boundary)

  Creates a new `FormData::Builder` which writes to io, using the multipart boundary boundary.

##
Instance Method Summary

- #boundary : String
- #content_type : String

  Returns a content type header with correct boundary parameter.

- #field(name : String, value, headers : HTTP::Headers = HTTP::Headers.new) : Nil

  Adds a form part with the given name and value.

- #file(name : String, io, metadata : FileMetadata = FileMetadata.new, headers : HTTP::Headers = HTTP::Headers.new)

  Adds a form part called name, with data from io as the value.

- #finish : Nil

  Finalizes the multipart message, this method must be called before the generated multipart message written to the IO is considered valid.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(io : IO, boundary : String = MIME::Multipart.generate_boundary) #

Creates a new `FormData::Builder` which writes to io, using the multipart boundary boundary.

##
Instance Method Detail

def boundary : String #
def content_type : String #

Returns a content type header with correct boundary parameter.

    builder = HTTP::FormData::Builder.new(io, "a4VF")
    builder.content_type # => "multipart/form-data; boundary=\"a4VF\""

def field(name : String, value, headers : HTTP::Headers = HTTP::Headers.new) : Nil #

Adds a form part with the given name and value. Headers can optionally be provided for the form part.

def file(name : String, io, metadata : FileMetadata = FileMetadata.new, headers : HTTP::Headers = HTTP::Headers.new) #

Adds a form part called name, with data from io as the value. Metadata can be provided to add extra metadata about the file to the Content-Disposition header for the form part. Other headers can be added using headers.

def finish : Nil #

Finalizes the multipart message, this method must be called before the generated multipart message written to the IO is considered valid.